/****************************************************************************

  (c) SYSTEC electronic GmbH, D-07973 Greiz, August-Bebel-Str. 29
      www.systec-electronic.de

  Project:      PLCmodule C14

  Description:  Demoprogram for the RTC driver

  -------------------------------------------------------------------------

                $RCSfile: RtcDemo.c,v $
                
                $Author: K.Otto $
                
                $Revision: 1.2 $  $Date: 2004/09/20 13:01:56 $
                
                $State: Exp $
                
                Build Environment:
                KEIL uVision 2

  -------------------------------------------------------------------------

  Revision History:

  2003/03/11 -ct:   start of the implementation

****************************************************************************/

#ifdef __C166__
    #include <xc161.h>
    #include <intrins.h>
#endif

#include "generic/global.h"
#include "../include/rtcdrv.h"



/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*          G L O B A L   D E F I N I T I O N S                            */
/*                                                                         */
/*                                                                         */
/***************************************************************************/

//---------------------------------------------------------------------------
// const defines
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// local types
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// modul globale vars
//---------------------------------------------------------------------------
tAlarmTime AlarmTime_g;

//---------------------------------------------------------------------------
// local function prototypes
//---------------------------------------------------------------------------
void SerInit(void);

//void RtcTimeHandler  (void);
//void RtcAlarmHandler (void);



void main(void)
{
BYTE         bRet;
BYTE         bOldSecond;
tRealTime    Time;


    bOldSecond    = 0;

    AlarmTime_g.bMinute  = 46;
    AlarmTime_g.bHour    = 10;
    AlarmTime_g.bDay     = 12;
    AlarmTime_g.bWeekday = 3;

    PSW_IEN = 1;

    printf("******************************************\n");
    printf("* Demoprogram for RTC Test               *\n");
    printf("* (c) SYS TEC electronic GmbH            *\n");
    printf("******************************************\n\n\n");

    printf("init RTC ...");
    bRet = RtcInit();
    if(bRet != RTC_SUCCESSFUL)
    {
        printf("\n*** Error on init of RTC 0x%02X\n",(WORD)bRet);
        while(1);
    }
    else
    {
        printf("o.k.\n");
    }

    bRet = RtcGetAbsTime(&Time);
    if(bRet != RTC_SUCCESSFUL)
    {
        printf("\n*** Error on reading the RTC 0x%02X\n",(WORD)bRet);
        while(1);
    }

    // check for valid time of the rtc
    if(Time.bTimeValid != TRUE)
    {
        printf("\n RTC time is invalid.");
    	Time.bSecond  = 0;
        Time.bMinute  = 42;
        Time.bHour    = 16;
        Time.bDay     = 12;
        Time.bWeekday = WEDNESDAY;
        Time.bMonth   = 11;
        Time.wYears   = 2003;
    
        printf("\nset time and date ...");
        bRet = RtcSetAbsTime(&Time);
        if(bRet != RTC_SUCCESSFUL)
        {
            printf("\n*** Error while setting the time 0x%02X\n",(WORD)bRet);
        }
        else
        {
            printf("o.k.\n");
        }
    }


    printf("actual time :\n");

    while(1)
    {

        bRet = RtcGetAbsTime(&Time);

        if(bOldSecond != Time.bSecond)
        {
            printf("date: %02d.%02d.%04d ",Time.bDay, Time.bMonth, Time.wYears);
            printf("time: %02d:%02d:%02d ", Time.bHour, Time.bMinute, Time.bSecond);

//            printf("AlarmFlag : 0x%02X ",(WORD)RtcGetAlarmFlag());
//            printf("abs. time : 0x%l08X",RtcGetRelTime());
            
            printf("\r");

            bOldSecond = Time.bSecond;
        }
    }

}


/****************************************************************************/
void SerInit(void)
{
/* init serial port */
    if (ASC0_CON == 0)
	{

	
    
    }
}

// EOF
